% MATLAB script to plot Sort execution times

% Define Q values
Q = 20:30;

% Define Sort execution times (converted to milliseconds)
sort_times = [
    3.134, 4.105, 6.074,    14,    29,    59,   120,   256,   554,  1164,  2453;  % V0 - ampere
    1.417, 2.193, 3.699, 8.329,    17,    37,    71,   153,   351,   742,  1556;  % V1 - ampere
    1.574, 2.411, 4.134,  8.94,    19,    40,    76,   163,   372,   788,  1650;  % V2 - ampere
    5.419,    10,    19,    40,    85,   181,   385,   826,  1762,  3765,  8034;  % V0 - tesla
    3.418, 6.995,    14,    30,    64,   139,   300,   648,  1394,  2992,  6411;  % V1 - tesla
    3.264, 6.728,    13,    29,    60,   129,   280,   606,  1308,  2815,  6048;  % V2 - tesla
       15,    30,    66,   142,   305,   654,  1408,  3009,  6445, 13750,   NaN;  % V0 - gtx1650
    6.666,    14,    31,    67,   139,   311,   689,  1539,  3358,  7428,   NaN;  % V1 - gtx1650
    7.294,    15,    33,    70,   148,   328,   726,  1609,  3527,  7749,   NaN   % V2 - gtx1650
];

% Plot in log scale
figure('Name', 'Results-SortTime', 'Position', [100, 100, 1600, 900]);
semilogy(Q, sort_times', '-o', 'LineWidth', 1.5);
grid on;
xlabel('Q (Memory Size)');
ylabel('Sort Execution Time (ms)');
title('Sort time over memory size');
legend({'V0 ampere', 'V1 ampere', 'V2 ampere', 'V0 tesla', 'V1 tesla', 'V2 tesla', 'V0 gtx1650', 'V1 gtx1650', 'V2 gtx1650'}, 'Location', 'northwest');
saveas(gcf, 'sort_time_plot.png');